#ifndef PROTOCOL_H
#define PROTOCOL_H
#include <time.h>
#include "global.h"

#define CMD_SUPPORTED 0
#define CMD_NOT_SUPPORTED 1
#define CMD_ERROR 2

typedef struct events_ {
   char call[300]; //Function called 'call' in Modul
   int (*func) (Threads *thread, int ac, char **av);
   int check_param;
   struct events_ *next, *prev;
}Event;

typedef struct protocol_ {
	char Author[70]; //Author of the CommandModul
	char Version[70]; //Version of the CommandModul
	  
	char *NSMode;
	char *CSMode;
	char *MSMode;
	char *HSMode;
	char *OSMode;
	char *BSMode;
	char *HeServMode;
	char *GlobMode;
	char *QMode;
	char *SCMode;
	char *BSBotsMode;
	char *ChannelModes;
	char *ParametricChannelModes;
	char *MLockAbleModes;
	char *OnSuspend;
	char *OnUnSuspend;
	int  SupportSVS;
	int  SupportSVSJoin;
	int  SvsNick;
	int  VHost;
	int  HasOwner;
	int  HasProtect;
	char  OwnerMode;
	char  ProtectMode;
	char  OpMode;
	char  HOpMode;
	char  VMode;
	char  BanMode;
	char  ExceptMode;
	char *SupportedUChanModes;
	char *SupportedU2ChanModes;
	char *SupportedUserModes;
	char *ModeOnNickReg;
	char *ModeOnNickDrop;
	char *ModeOnChannelReg;
	char *ModeOnChannelDrop;
	char RegMode;
	int  ChanRegMode;
	int  NickRegMode;
	int  SupportSGlines;
	int  SupportSQlines;
	int  SupportSZlines;
	int  SupportHalfOp;
	int  SupportBanMode;
	int  SupportExceptMode;
	int  SupportProtectUmode;
	char *ProtectUmode;
	int  SupportInvisibleUMode;
	char *InvisibleUMode;
	int  SupportChanSQlines;
	int  DoesGlobalChangeAfterSVS;
	int  DoesGlobalChangeAfterSA;
	int  DoesQuitAfterKill;
	int  SupportVIdents;
	int  VHostOnNickChange;
	int  SupportRealnameChanges;
	int  SupportAdminOnlyChanMode;
	int  SupportOperOnlyChanMode;
	char *AdminOnlyCMode;
	char *OperOnlyCMode;
	char *DefaultMLOCK;
	char  VhostMode;
	int  SupportFloodMode;
	int  SupportLinkMode;
	char FloodCMode;
	char LinkCMode;
	char LimitCMode;
	char KeyCMode;
	char InviteCMode;
	int  SupportTokens;
	int  SupportSjoin;
	int  SupportSjoinBanprefix;
	int  SupportSjoinExceptprefix;
	char  SjoinOwnerPrefix;
	char  SjoinProtectPrefix;
	char  SjoinOpPrefix;
	char  SjoinHOpPrefix;
	char  SjoinVoicePrefix;
	char  SjoinBanPrefix;
	char  SjoinExceptPrefix;
	int  SjoinHasIgnoreChar;
	char  SjoinIgnoredChar;
	int  SupportHelperUMode;
	int  SupportSyncState;
	int  p10protocol;
	int  p10new;
   
	void *dl_handle; //Dynamic Library Handle with which the library was opened.
	int (*func_finish) (void); //Finish function - is called before unloading the module
	Event *events;
   
	int (*orion_cmd_initialize) (Threads *thread);
	int (*orion_cmd_add_account) (Threads *thread, char *uid, char *authnick);
	int (*orion_cmd_del_account) (Threads *thread, char *uid);
	int (*orion_cmd_topic) (Threads *thread, char *whosets, char *chan, char *whosetit, char *topic, long when);
	int (*orion_cmd_kill) (Threads *thread, char *source, char *user, char *buf);
	int (*orion_cmd_gline) (Threads *thread, char *user, char *host, char *who, long when, long expires, char *reason);
	int (*orion_cmd_ungline) (Threads *thread, char *unsetter, char *host, char *user, long time_in);
	int (*orion_cmd_svskill) (Threads *thread, char *source, char *user, char *buf);
	int (*orion_cmd_rawsvsmode) (Threads *thread, char *nick, char *target, char *modes);
	int (*orion_cmd_svsmode) (Threads *thread, char *nick, char *target, char *modes);
	int (*orion_cmd_svs2mode) (Threads *thread, char *nick, char *target, char *modes);
	int (*orion_cmd_nick) (Threads *thread, char *nick, char *ident, char *host, char *name, char *modes);
	int (*orion_cmd_mode) (Threads *thread, char *source, char *dest, long time_in, char *buf);
	int (*orion_cmd_rawmode) (Threads *thread, char *source, char *dest, long time_in, char *buf);
	int (*orion_cmd_kick) (Threads *thread, char *source, char *chan, char *user, char *buf);
	int (*orion_cmd_notice) (Threads *thread, char *source, char *dest, char *buf);
	int (*orion_cmd_privmsg) (Threads *thread, char *source, char *dest, char *buf);
	int (*orion_cmd_serv_notice) (Threads *thread, char *source, char *dest, char *msg);
	int (*orion_cmd_serv_privmsg) (Threads *thread, char *source, char *dest, char *msg);
	
	int (*orion_cmd_quit) (Threads *thread, char *source, char *buf);
	int (*orion_cmd_protoctl) (Threads *thread);
	int (*orion_cmd_pass) (Threads *thread, char *pass);
	int (*orion_cmd_server) (Threads *thread, char *servname, int hop, char *descript);
	int (*orion_cmd_pong) (Threads *thread, char *servname, char *who);
	int (*orion_cmd_ping) (Threads *thread, char *servname, char *who);
	int (*orion_cmd_join) (Threads *thread, char *user, char *channel, long chantime);
	int (*orion_cmd_services_join) (Threads *thread, char *user, char *channel, long chantime, int fake);

	int (*orion_cmd_chghost) (Threads *thread, char *source, char *nick, char *vhost);
	int (*orion_cmd_chgident) (Threads *thread, char *source, char *nick, char *vIdent);
	int (*orion_cmd_invite) (Threads *thread, char *source, char *chan, char *nick);
	int (*orion_cmd_part) (Threads *thread, char *nick, char *chan, char *buf);
	int (*orion_cmd_global) (Threads *thread, char *source, char *buf);
	
	int (*orion_cmd_squit) (Threads *thread, char *servname, char *message);
	int (*orion_cmd_svso) (Threads *thread, char *source, char *nick, char *flag);
	int (*orion_cmd_chg_nick) (Threads *thread, char *oldnick, char *newnick);
	int (*orion_cmd_svsnick) (Threads *thread, char *source, char *oldnick, char *newnick, long when);
	int (*orion_cmd_connect) (Threads *thread, int how);
	int (*orion_cmd_svshold) (Threads *thread, char *nick);
	int (*orion_cmd_release_svshold) (Threads *thread, char *nick);
	
	int (*orion_cmd_sqline) (Threads *thread, char *sender, char *mask, long time_in, long expire, char *reason);
	int (*orion_cmd_unsqline) (Threads *thread, char *servername, char *nick, char *snick);
	
	int (*orion_cmd_szline) (Threads *thread, char *servername, char *mask, char *snick, long when, long expire, char *reason);
	int (*orion_cmd_unszline) (Threads *thread, char *servername, char *mask, char *snick, long in_time);
	
	int (*orion_cmd_unban) (Threads *thread, char *name, char *nick);
	int (*orion_cmd_svsmode_chan) (Threads *thread, char *name, char *mode, char *nick);
	int (*orion_cmd_svsjoin) (Threads *thread, char *source, char *nick, char *chan, long date);
	int (*orion_cmd_svspart) (Threads *thread, char *source, char *nick, char *chan);
	int (*orion_cmd_sajoin) (Threads *thread, char *source, char *nick, char *chan, long date);
	int (*orion_cmd_sapart) (Threads *thread, char *source, char *nick, char *chan);
	int (*orion_cmd_wallops) (Threads *thread, char *source, char *fmt);
	
	int (*orion_cmd_swhois) (Threads *thread, char *source, char *who, char *mask);
	int (*orion_cmd_eob) (Threads *thread);
	int (*orion_cmd_jupe) (Threads *thread, char *jserver, char *who, char *reason);
	int (*orion_cmd_global_legacy) (Threads *thread, char *source, char *fmt);
	int (*orion_valid_nick) (Threads *thread, char *nick);
	int (*orion_flood_mode_check) (Threads *thread, char *value);
}Protocol;

int LoadProtocol(Threads *thread, Protocol *protocol, char *IRCd);
int on_protocol (Threads *thread, Protocol *protocol, int ac, char *param[]);

void CreateProtocol(Threads *thread, Protocol *protocol, void *dl_handle);
void event_init    (Threads *thread, Protocol *protocol, void *dl_handle, char *Author, char *Version);

void createEvent(Threads *thread, Protocol *protocol,
	const char *call,
	int (func) (Threads *thread, int ac, char **av),
	int check_param
	);
#endif
